#include <iostream>
#include <vector>
#include "svg.h"
// #include"svg_rect.h"

const auto IMAGE_WIDTH = 400;
const auto IMAGE_HEIGHT = 300;
const auto TEXT_LEFT = 20;
const auto TEXT_BASELINE = 20;
const auto TEXT_WIDTH = 50;
const auto BIN_HEIGHT = 30;
const auto BLOCK_WIDTH = 10;

void svg_begin(double width, double height)
{
    std::cout << "<?xml version='1.0' encoding='UTF-8'?>\n";
    std::cout << "<svg ";
    std::cout << "width='" << width << "' ";
    std::cout << "height='" << height << "' ";
    std::cout << "viewBox='0 0 " << width << " " << height << "' ";
    std::cout << "xmlns='http://www.w3.org/2000/svg'>\n";
}

void svg_end()
{
    std::cout << "</svg>\n";
}

void svg_text(double left, double baseline, std::string text)
{
    // std::cout << "<text x='20' y='35'>text</text>";

    std::cout << "<text x=' " << left << " ' y='" << baseline << "' > " << text << " </text>";

    // std::cout << "<text x='20' y='" << baseline << "' >2</text>";
}

void svg_rect(double x, double y, double width, double height)
{

    std::cout << "<rect x='" << x << "' y='" << y << "' width='" << width << "' height='" << height << " ' stroke='yellow' fill='#9932CC' ></rect>";
}

void show_histogram_svg(const std::vector<int> &bins)
{
    const auto SCALE = (IMAGE_WIDTH - TEXT_WIDTH);
    const auto IMAGE_WIDTH = 400;
    const auto IMAGE_HEIGHT = 300;
    const auto TEXT_LEFT = 20;
    const auto TEXT_BASELINE = 20;
    const auto TEXT_WIDTH = 50;
    const auto BIN_HEIGHT = 30;
    const auto BLOCK_WIDTH = 10;
    svg_begin(IMAGE_WIDTH, IMAGE_HEIGHT);
    double top = 0;
    for (size_t bin : bins)
    {
        double bin_width = BLOCK_WIDTH * bin;

        if (bin_width > SCALE)
        {
            bin_width = SCALE;
        }

        svg_text(TEXT_LEFT, top + TEXT_BASELINE, std::to_string(bin));
        svg_rect(TEXT_WIDTH, top, bin_width, BIN_HEIGHT);
        top += BIN_HEIGHT;
    }

    svg_end();
}
